## nodejs 0.4.12

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(node)

if(USE_GCOV)
  set(CMAKE_BUILD_TYPE "Debug")

  # Set global c and c++ flags
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")

  # Link flags used for creating executables
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lgcov -fprofile-arcs")

  # Link flags used for creating shared libraries
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lgcov -profile-arcs")
endif()

#
# options
#

find_package(PythonInterp 2 REQUIRED)

option(SHARED_V8 "use system shared V8 library")
option(SHARED_LIBEV "use system shared libev library")
option(SHARED_CARES "use system shared c-ares library")
option(V8_SNAPSHOT "turn on snapshot when building stock v8")
option(V8_OPROFILE "Add oprofile support")
option(V8_GDBJIT "add gdbjit support")
option(DTRACE "build with DTrace (experimental)")

# cmake policies to get rid of some warnings
cmake_policy(SET CMP0009 NEW) # GLOB_RECURSE should no follow symlinks

# generic cmake configuration
include("cmake/configure.cmake")

# find and configure libs
include("cmake/libs.cmake")

# setup node build targets
include("cmake/node_build.cmake")

# setup v8 build targets
include("cmake/v8_build.cmake")

# docs
## might want to move this to doc/CMakeLists.txt
include("cmake/docs.cmake")

# tests
enable_testing()
include(CTest)
add_subdirectory("test/")

# package
include("cmake/package.cmake")


#
# Final build configuration output
#

message("** Build Summary **")
message("  Version:            ${node_version_string}")
message("  Prefix:             ${PREFIX}")
message("  Build Type:         ${CMAKE_BUILD_TYPE}")
message("  Architecture:       ${CMAKE_SYSTEM_PROCESSOR}")
message("  Platform:           ${node_platform}")

if(SHARED_V8)
message("  V8:                 ${V8_LIBRARY_PATH}")
#else()
#message(" V8 jobs:            ${parallel_jobs}")
endif()

if(SHARED_libev)
  message("  libev:              ${LIBEV_LIBRARY}")
endif()

if(SHARED_CARES)
  message("  libc-ares:          ${LIBCARES_LIBRARY}")
endif()

message("  RT library:         ${RT}")
message("  DL library:         ${DL}")

if(${OPENSSL_FOUND} MATCHES TRUE)
  message("  OpenSSL:            ${OPENSSL_LIBRARIES}")
endif()

if(USE_GCOV)
  message("  gcov:               enabled")
endif()

message("  CCFLAGS:            ${CCFLAGS}")
message("  CPPFLAGS:           ${CPPFLAGS}")

=== Makefile ===
WAF=python tools/waf-light

web_root = ryan@nodejs.org:~/web/nodejs.org/

all: program

all-progress:
	@$(WAF) -p build

program:
	@$(WAF) --product-type=program build

staticlib:
	@$(WAF) --product-type=cstaticlib build

dynamiclib:
	@$(WAF) --product-type=cshlib build

install:
	@$(WAF) install

uninstall:
	@$(WAF) uninstall

test: all
	python tools/test.py --mode=release simple message

test-valgrind: all
	python tools/test.py --mode=release --valgrind simple message

test-all: all
	python tools/test.py --mode=debug,release

test-all-valgrind: all
	python tools/test.py --mode=debug,release --valgrind

test-release: all
	python tools/test.py --mode=release

test-debug: all
	python tools/test.py --mode=debug

test-message: all
	python tools/test.py message

test-simple: all
	python tools/test.py simple

test-pummel: all
	python tools/test.py pummel

test-internet: all
	python tools/test.py internet

build/default/node: all

apidoc_sources = $(wildcard doc/api/*.markdown)
apidocs = $(addprefix build/,$(apidoc_sources:.markdown=.html))

apidoc_dirs = build/doc build/doc/api/ build/doc/api/assets

apiassets = $(subst api_assets,api/assets,$(addprefix build/,$(wildcard doc/api_assets/*)))

website_files = \
	build/doc/index.html    \
	build/doc/v0.4_announcement.html   \
	build/doc/cla.html      \
	build/doc/sh_main.js    \
	build/doc/sh_javascript.min.js \
	build/doc/sh_vim-dark.css \
	build/doc/logo.png      \
	build/doc/sponsored.png \
  build/doc/favicon.ico   \
	build/doc/pipe.css

doc: build/default/node $(apidoc_dirs) $(website_files) $(apiassets) $(apidocs)

$(apidoc_dirs):
	mkdir -p $@

build/doc/api/assets/%: doc/api_assets/% build/doc/api/assets/
	cp $< $@

build/doc/%: doc/%
	cp $< $@

build/doc/api/%.html: doc/api/%.markdown build/default/node $(apidoc_dirs) $(apiassets) tools/doctool/doctool.js
	build/default/node tools/doctool/doctool.js doc/template.html $< > $@

build/doc/%:

website-upload: doc
	scp -r build/doc/* $(web_root)

docopen: build/doc/api/all.html
	-google-chrome build/doc/api/all.html

docclean:
	-rm -rf build/doc

clean:
	$(WAF) clean
	-find tools -name "*.pyc" | xargs rm -f

distclean: docclean
	-find tools -name "*.pyc" | xargs rm -f
	-rm -rf build/ node node_g

check:
	@tools/waf-light check

VERSION=$(shell git describe)
TARNAME=node-$(VERSION)

#dist: doc/node.1 doc/api
dist: doc
	git archive --format=tar --prefix=$(TARNAME)/ HEAD | tar xf -
	mkdir -p $(TARNAME)/doc
	cp doc/node.1 $(TARNAME)/doc/node.1
	cp -r build/doc/api $(TARNAME)/doc/api
	rm -rf $(TARNAME)/deps/v8/test # too big
	tar -cf $(TARNAME).tar $(TARNAME)
	rm -rf $(TARNAME)
	gzip -f -9 $(TARNAME).tar

bench:
	 benchmark/http_simple_bench.sh

bench-idle:
	./node benchmark/idle_server.js &
	sleep 1
	./node benchmark/idle_clients.js &

jslint:
	PYTHONPATH=tools/closure_linter/ python tools/closure_linter/closure_linter/gjslint.py --unix_mode --strict --nojsdoc -r lib/ -r src/ -r test/

cpplint:
	@python tools/cpplint.py $(wildcard src/*.cc src/*.h src/*.c)

lint: jslint cpplint

.PHONY: lint cpplint jslint bench clean docopen docclean doc dist distclean check uninstall install all program staticlib dynamiclib test test-all website-upload

=== wscript ===
#!/usr/bin/env python

# Copyright Joyent, Inc. and other Node contributors.
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to permit
# persons to whom the Software is furnished to do so, subject to the
# following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
# NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
# USE OR OTHER DEALINGS IN THE SOFTWARE.

import re
import Options
import sys, os, shutil, glob
import Utils
from Utils import cmd_output
from os.path import join, dirname, abspath, normpath
from logging import fatal

cwd = os.getcwd()
APPNAME="node.js"

# Use the directory that this file is found in to find the tools
# directory where the js2c.py file can be found.
sys.path.append(sys.argv[0] + '/tools');
import js2c

srcdir = '.'
blddir = 'build'
supported_archs = ('arm', 'ia32', 'x64') # 'mips' supported by v8, but not node

jobs=1
if os.environ.has_key('JOBS'):
  jobs = int(os.environ['JOBS'])

def safe_path(path):
  return path.replace("\\", "/")

def canonical_cpu_type(arch):
  m = {'x86': 'ia32', 'i386':'ia32', 'x86_64':'x64', 'amd64':'x64'}
  if arch in m: arch = m[arch]
  if not arch in supported_archs:
    raise Exception("supported architectures are "+', '.join(supported_archs)+\
                    " but NOT '" + arch + "'.")
  return arch

def set_options(opt):
  # the gcc module provides a --debug-level option
  opt.tool_options('compiler_cxx')
  opt.tool_options('compiler_cc')
  opt.tool_options('misc')
  opt.add_option( '--libdir'
		, action='store'
		, type='string'
		, default=False
		, help='Install into this libdir [Default: ${PREFIX}/lib]'
		)
  opt.add_option( '--debug'
                , action='store_true'
                , default=False
                , help='Build debug variant [Default: False]'
                , dest='debug'
                )
  opt.add_option( '--profile'
                , action='store_true'
                , default=False
                , help='Enable profiling [Default: False]'
                , dest='profile'
                )
  opt.add_option( '--efence'
                , action='store_true'
                , default=False
                , help='Build with -lefence for debugging [Default: False]'
                , dest='efence'
                )

  opt.add_option( '--without-snapshot'
                , action='store_true'
                , default=False
                , help='Build without snapshotting V8 libraries. You might want to set this for cross-compiling. [Default: False]'
                , dest='without_snapshot'
                )

  opt.add_option( '--without-ssl'
                , action='store_true'
                , default=False
                , help='Build without SSL'
                , dest='without_ssl'
                )


  opt.add_option('--shared-v8'
                , action='store_true'
                , default=False
                , help='Link to a shared V8 DLL instead of static linking'
                , dest='shared_v8'
                )

  opt.add_option( '--shared-v8-includes'
                , action='store'
                , default=False
                , help='Directory containing V8 header files'
                , dest='shared_v8_includes'
                )

  opt.add_option( '--shared-v8-libpath'
                , action='store'
                , default=False
                , help='A directory to search for the shared V8 DLL'
                , dest='shared_v8_libpath'
                )

  opt.add_option( '--shared-v8-libname'
                , action='store'
                , default=False
                , help="Alternative lib name to link to (default: 'v8')"
                , dest='shared_v8_libname'
                )

  opt.add_option( '--openssl-includes'
                , action='store'
                , default=False
                , help='A directory to search for the OpenSSL includes'
                , dest='openssl_includes'
                )

  opt.add_option( '--openssl-libpath'
                , action='store'
                , default=False
                , help="A directory to search for the OpenSSL libraries"
                , dest='openssl_libpath'
                )

  opt.add_option( '--no-ssl2'
                , action='store_true'
                , default=False
                , help="Disable OpenSSL v2"
                , dest='openssl_nov2'
                )

  opt.add_option( '--gdb'
                , action='store_true'
                , default=False
                , help="add gdb support"
                , dest='use_gdbjit'
                )


  opt.add_option('--shared-cares'
                , action='store_true'
                , default=False
                , help='Link to a shared C-Ares DLL instead of static linking'
                , dest='shared_cares'
                )

  opt.add_option( '--shared-cares-includes'
                , action='store'
                , default=False
                , help='Directory containing C-Ares header files'
                , dest='shared_cares_includes'
                )

  opt.add_option( '--shared-cares-libpath'
                , action='store'
                , default=False
                , help='A directory to search for the shared C-Ares DLL'
                , dest='shared_cares_libpath'
                )


  opt.add_option('--shared-libev'
                , action='store_true'
                , default=False
                , help='Link to a shared libev DLL instead of static linking'
                , dest='shared_libev'
                )

  opt.add_option( '--shared-libev-includes'
                , action='store'
                , default=False
                , help='Directory containing libev header files'
                , dest='shared_libev_includes'
                )

  opt.add_option( '--shared-libev-libpath'
                , action='store'
                , default=False
                , help='A directory to search for the shared libev DLL'
                , dest='shared_libev_libpath'
                )

  opt.add_option( '--with-dtrace'
                , action='store_true'
                , default=False
                , help='Build with DTrace (experimental)'
                , dest='dtrace'
                )
 

  opt.add_option( '--product-type'
                , action='store'
                , default='program'
                , help='What kind of product to produce (program, cstaticlib '\
                       'or cshlib) [default: %default]'
                , dest='product_type'
                )

  opt.add_option( '--dest-cpu'
                , action='store'
                , default=None
                , help='CPU architecture to build for. Valid values are: '+\
                       ', '.join(supported_archs)
                , dest='dest_cpu'
                )




def configure(conf):
  conf.check_tool('compiler_cxx')
  if not conf.env.CXX: conf.fatal('c++ compiler not found')
  conf.check_tool('compiler_cc')
  if not conf.env.CC: conf.fatal('c compiler not found')

  o = Options.options

  if o.libdir:
    conf.env['LIBDIR'] = o.libdir
  else:
    conf.env['LIBDIR'] = conf.env['PREFIX'] + '/lib'

  conf.env["USE_DEBUG"] = o.debug
  # Snapshot building does noet seem to work on cygwin and mingw32
  conf.env["SNAPSHOT_V8"] = not o.without_snapshot and not sys.platform.startswith("win32")
  if sys.platform.startswith("sunos"):
    conf.env["SNAPSHOT_V8"] = False
  conf.env["USE_PROFILING"] = o.profile

  conf.env["USE_SHARED_V8"] = o.shared_v8 or o.shared_v8_includes or o.shared_v8_libpath or o.shared_v8_libname
  conf.env["USE_SHARED_CARES"] = o.shared_cares or o.shared_cares_includes or o.shared_cares_libpath
  conf.env["USE_SHARED_LIBEV"] = o.shared_libev or o.shared_libev_includes or o.shared_libev_libpath

  conf.env["USE_GDBJIT"] = o.use_gdbjit

  conf.check(lib='dl', uselib_store='DL')
  if not sys.platform.startswith("sunos") and not sys.platform.startswith("cygwin") and not sys.platform.startswith("win32"):
    conf.env.append_value("CCFLAGS", "-rdynamic")
    conf.env.append_value("LINKFLAGS_DL", "-rdynamic")

  if sys.platform.startswith("freebsd") or sys.platform.startswith("openbsd"):
    conf.check(lib='kvm', uselib_store='KVM')

  #if Options.options.debug:
  #  conf.check(lib='profiler', uselib_store='PROFILER')

  if Options.options.dtrace:
    if not sys.platform.startswith("sunos"):
      conf.fatal('DTrace support only currently available on Solaris')

    conf.find_program('dtrace', var='DTRACE', mandatory=True)
    conf.env["USE_DTRACE"] = True
    conf.env.append_value("CXXFLAGS", "-DHAVE_DTRACE=1")

  if Options.options.efence:
    conf.check(lib='efence', libpath=['/usr/lib', '/usr/local/lib'], uselib_store='EFENCE')

  if sys.platform.startswith("freebsd"):
     if not conf.check(lib="execinfo",
                       includes=['/usr/include', '/usr/local/include'],
                       libpath=['/usr/lib', '/usr/local/lib'],
                       uselib_store="EXECINFO"):
       conf.fatal("Install the libexecinfo port from /usr/ports/devel/libexecinfo.")

  if not Options.options.without_ssl:
    # Don't override explicitly supplied openssl paths with pkg-config results.
    explicit_openssl = o.openssl_includes or o.openssl_libpath

    # Disable ssl v2 methods
    if o.openssl_nov2:
      conf.env.append_value("CPPFLAGS", "-DOPENSSL_NO_SSL2=1")

    if not explicit_openssl and conf.check_cfg(package='openssl',
                                               args='--cflags --libs',
                                               uselib_store='OPENSSL'):
      Options.options.use_openssl = conf.env["USE_OPENSSL"] = True
      conf.env.append_value("CPPFLAGS", "-DHAVE_OPENSSL=1")
    else:
      if o.openssl_libpath: 
        openssl_libpath = [o.openssl_libpath]
      elif not sys.platform.startswith('win32'):
        openssl_libpath = ['/usr/lib', '/usr/local/lib', '/opt/local/lib', '/usr/sfw/lib']
      else:
        openssl_libpath = [normpath(join(cwd, '../openssl'))]

      if o.openssl_includes: 
        openssl_includes = [o.openssl_includes]
      elif not sys.platform.startswith('win32'):
        openssl_includes = [];
      else:
        openssl_includes = [normpath(join(cwd, '../openssl/include'))];

      openssl_lib_names = ['ssl', 'crypto']
      if sys.platform.startswith('win32'):
        openssl_lib_names += ['ws2_32', 'gdi32']

      libssl = conf.check_cc(lib=openssl_lib_names,
                             header_name='openssl/ssl.h',
                             function_name='SSL_library_init',
                             includes=openssl_includes,
                             libpath=openssl_libpath,
                             uselib_store='OPENSSL')

      libcrypto = conf.check_cc(lib='crypto',
                                header_name='openssl/crypto.h',
                                includes=openssl_includes,
                                libpath=openssl_libpath,
                                uselib_store='OPENSSL')

      if libcrypto and libssl:
        conf.env["USE_OPENSSL"] = Options.options.use_openssl = True
        conf.env.append_value("CPPFLAGS", "-DHAVE_OPENSSL=1")
      elif sys.platform.startswith('win32'):

=== deps/libeio/CMakeLists.txt ===
include(CheckFunctionExists)
include(FindThreads)

if(!${CMAKE_USE_PTHREADS_INIT})
    message(FATAL_ERROR "Unable to find pthreads")
endif()

add_definitions(-DHAVE_CONFIG_H=1 -D_GNU_SOURCE)

check_function_exists(futimes HAVE_FUTIMES)
check_function_exists(readahead HAVE_READAHEAD)
check_function_exists(fdatasync HAVE_FDATASYNC)
check_function_exists(pread HAVE_PREAD)
check_function_exists(pwrite HAVE_PWRITE)
check_function_exists(sendfile HAVE_SENDFILE)
check_function_exists(sync_file_range HAVE_SYNC_FILE_RANGE)

if(${HAVE_PREAD} AND ${HAVE_PWRITE})
   set(HAVE_PREADWRITE 1)
endif()

configure_file(config.h.cmake ${PROJECT_BINARY_DIR}/deps/libeio/config.h)
include_directories(${PROJECT_BINARY_DIR}/deps/libeio)

add_library(eio eio.c)
target_link_libraries(eio ${CMAKE_THREAD_LIBS_INIT})

=== deps/libev/CMakeLists.txt ===
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckLibraryExists)

#include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${PROJECT_BINARY_DIR}/deps/libev)
add_definitions(-DHAVE_CONFIG_H=1 -DEV_MULTIPLICITY=0)

check_include_files(sys/inotify.h HAVE_SYS_INOTIFY_H)
check_include_files(sys/epoll.h HAVE_SYS_EPOLL_H)
check_include_files(sys/event.h HAVE_SYS_EVENT_H)
check_include_files(sys/queue.h HAVE_SYS_QUEUE_H)
check_include_files(port.h HAVE_PORT_H)
check_include_files(poll.h HAVE_POLL_H)
check_include_files(sys/select.h HAVE_SYS_SELECT_H)
check_include_files(sys/eventfd.h HAVE_SYS_EVENTFD_H)

check_function_exists(inotify_init HAVE_INOTIFY_INIT)
check_function_exists(epoll_ctl HAVE_EPOLL_CTL)
check_function_exists(kqueue HAVE_KQUEUE)
check_function_exists(port_create HAVE_PORT_CREATE)
check_function_exists(poll HAVE_POLL)
check_function_exists(select HAVE_SELECT)
check_function_exists(eventfd HAVE_EVENTFD)
check_function_exists(nanosleep HAVE_NANOSLEEP)

# check first without rt
check_function_exists(clock_gettime HAVE_CLOCK_GETTIME)

check_library_exists(rt clock_gettime "" HAVE_LIBRT)
# then check with rt
check_library_exists(rt clock_gettime "" HAVE_CLOCK_GETTIME)

check_library_exists(m ceil "" HAVE_LIBM)

configure_file(config.h.cmake ${PROJECT_BINARY_DIR}/deps/libev/config.h)
add_library (ev ev.c)

=== deps/libev/wscript ===
import Options
import platform

PLATFORM_IS_DARWIN = platform.platform().find('Darwin') == 0
PLATFORM_IS_WIN32 = platform.platform().find('Win') >= 0

def set_options(opt):
  pass
  #opt.tool_options('compiler_cc')

def configure(conf):
  print "--- libev ---"
  #conf.check_tool('compiler_cc')

  # Why to the two checks? One is to define HAVE_SYS_EPOLL_H
  # the other is to define HAVE_EPOLL_CTL
  # Yes, WAF is a piece of shit.

  if conf.check_cc(header_name="sys/inotify.h"):
    conf.check_cc(header_name="sys/inotify.h", function_name="inotify_init")

  if conf.check_cc(header_name="sys/epoll.h"):
    conf.check_cc(header_name="sys/epoll.h", function_name="epoll_ctl")

  if conf.check_cc(header_name="port.h"):
    conf.check_cc(header_name="port.h", function_name="port_create")

  if conf.check_cc(header_name="poll.h"):
    conf.check_cc(header_name="poll.h", function_name="poll")

  kqueue_headers = []
  # On FreeBSD event.h is not selfcontained and requires types.h
  event_headers = ["sys/types.h", "sys/event.h"]
  if conf.check_cc(header_name=event_headers, define_name="HAVE_SYS_EVENT_H"):
    kqueue_headers += event_headers

  if conf.check_cc(header_name="sys/queue.h"):
    kqueue_headers.append("sys/queue.h")

  if kqueue_headers:
    conf.check_cc(header_name=kqueue_headers, function_name="kqueue")

  if PLATFORM_IS_WIN32:
    # Windows has sys/select.h and select but this config line doesn't detect it properly
    conf.define('HAVE_SYS_SELECT_H', 1);
    conf.define('HAVE_SELECT', 1);
  else:
    if conf.check_cc(header_name="sys/select.h"):
      conf.check_cc(header_name="sys/select.h", function_name="select")

  if conf.check_cc(header_name="sys/eventfd.h"):
    conf.check_cc(header_name="sys/eventfd.h", function_name="eventfd")


  code = """
      #include <syscall.h>
      #include <time.h>
      #include <stdio.h>

      int main() {
          struct timespec ts; 
          int status = syscall(SYS_clock_gettime, CLOCK_REALTIME, &ts);
          return 0;
      }
  """
  conf.check_cc(fragment=code, define_name="HAVE_CLOCK_SYSCALL", execute=True,
                msg="Checking for SYS_clock_gettime")

  have_librt = conf.check(lib='rt', uselib_store='RT')
  if have_librt:
    conf.check_cc(lib="rt", header_name="time.h", function_name="clock_gettime")
  if PLATFORM_IS_DARWIN:
    conf.check_cc(header_name="time.h", function_name="nanosleep")
  elif have_librt:
    conf.check_cc(lib="rt", header_name="time.h", function_name="nanosleep")

  conf.check_cc(lib="m", header_name="math.h", function_name="ceil")

  conf.define("HAVE_CONFIG_H", 1)
  # Not using these.
  conf.env.append_value('CPPFLAGS', ['-DEV_FORK_ENABLE=0',
                                     '-DEV_EMBED_ENABLE=0',
                                     '-DEV_MULTIPLICITY=0'])

def build(bld):
  libev = bld.new_task_gen("cc")
  libev.source = 'ev.c'
  libev.target = 'ev'
  libev.name = 'ev'
  libev.includes = '. ../..'
  libev.uselib = "RT"
  libev.install_path = None
  if bld.env["USE_DEBUG"]:
    libev.clone("debug");
  bld.install_files('${PREFIX}/include/node/', 'ev.h');

=== deps/v8/SConstruct ===
# Copyright 2010 the V8 project authors. All rights reserved.
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#     * Neither the name of Google Inc. nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import platform
import re
import subprocess
import sys
import os
from os.path import join, dirname, abspath
from types import DictType, StringTypes
root_dir = dirname(File('SConstruct').rfile().abspath)
sys.path.insert(0, join(root_dir, 'tools'))
import js2c, utils

# ANDROID_TOP is the top of the Android checkout, fetched from the environment
# variable 'TOP'.   You will also need to set the CXX, CC, AR and RANLIB
# environment variables to the cross-compiling tools.
ANDROID_TOP = os.environ.get('TOP')
if ANDROID_TOP is None:
  ANDROID_TOP=""

# ARM_TARGET_LIB is the path to the dynamic library to use on the target
# machine if cross-compiling to an arm machine. You will also need to set
# the additional cross-compiling environment variables to the cross compiler.
ARM_TARGET_LIB = os.environ.get('ARM_TARGET_LIB')
if ARM_TARGET_LIB:
  ARM_LINK_FLAGS = ['-Wl,-rpath=' + ARM_TARGET_LIB + '/lib:' +
                     ARM_TARGET_LIB + '/usr/lib',
                    '-Wl,--dynamic-linker=' + ARM_TARGET_LIB +
                    '/lib/ld-linux.so.3']
else:
  ARM_LINK_FLAGS = []

GCC_EXTRA_CCFLAGS = []
GCC_DTOA_EXTRA_CCFLAGS = []

ANDROID_FLAGS = ['-march=armv7-a',
                 '-mtune=cortex-a8',
                 '-mfloat-abi=softfp',
                 '-mfpu=vfp',
                 '-fpic',
                 '-mthumb-interwork',
                 '-funwind-tables',
                 '-fstack-protector',
                 '-fno-short-enums',
                 '-fmessage-length=0',
                 '-finline-functions',
                 '-fno-inline-functions-called-once',
                 '-fgcse-after-reload',
                 '-frerun-cse-after-loop',
                 '-frename-registers',
                 '-fomit-frame-pointer',
                 '-finline-limit=64',
                 '-DCAN_USE_VFP_INSTRUCTIONS=1',
                 '-DCAN_USE_ARMV7_INSTRUCTIONS=1',
                 '-DCAN_USE_UNALIGNED_ACCESSES=1',
                 '-MD']

ANDROID_INCLUDES = [ANDROID_TOP + '/bionic/libc/arch-arm/include',
                    ANDROID_TOP + '/bionic/libc/include',
                    ANDROID_TOP + '/bionic/libstdc++/include',
                    ANDROID_TOP + '/bionic/libc/kernel/common',
                    ANDROID_TOP + '/bionic/libc/kernel/arch-arm',
                    ANDROID_TOP + '/bionic/libm/include',
                    ANDROID_TOP + '/bionic/libm/include/arch/arm',
                    ANDROID_TOP + '/bionic/libthread_db/include',
                    ANDROID_TOP + '/frameworks/base/include',
                    ANDROID_TOP + '/system/core/include']

ANDROID_LINKFLAGS = ['-nostdlib',
                     '-Bdynamic',
                     '-Wl,-T,' + ANDROID_TOP + '/build/core/armelf.x',
                     '-Wl,-dynamic-linker,/system/bin/linker',
                     '-Wl,--gc-sections',
                     '-Wl,-z,nocopyreloc',
                     '-Wl,-rpath-link=' + ANDROID_TOP + '/out/target/product/generic/obj/lib',
                     ANDROID_TOP + '/out/target/product/generic/obj/lib/crtbegin_dynamic.o',
                     ANDROID_TOP + '/prebuilt/linux-x86/toolchain/arm-eabi-4.4.0/lib/gcc/arm-eabi/4.4.0/interwork/libgcc.a',
                     ANDROID_TOP + '/out/target/product/generic/obj/lib/crtend_android.o'];

LIBRARY_FLAGS = {
  'all': {
    'CPPPATH': [join(root_dir, 'src')],
    'regexp:interpreted': {
      'CPPDEFINES': ['V8_INTERPRETED_REGEXP']
    },
    'mode:debug': {
      'CPPDEFINES': ['V8_ENABLE_CHECKS', 'OBJECT_PRINT']
    },
    'vmstate:on': {
      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING'],
    },
    'objectprint:on': {
      'CPPDEFINES':   ['OBJECT_PRINT'],
    },
    'protectheap:on': {
      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING', 'ENABLE_HEAP_PROTECTION'],
    },
    'profilingsupport:on': {
      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING', 'ENABLE_LOGGING_AND_PROFILING'],
    },
    'debuggersupport:on': {
      'CPPDEFINES':   ['ENABLE_DEBUGGER_SUPPORT'],
    },
    'inspector:on': {
      'CPPDEFINES':   ['INSPECTOR'],
    },
    'liveobjectlist:on': {
      'CPPDEFINES':   ['ENABLE_DEBUGGER_SUPPORT', 'INSPECTOR',
                       'LIVE_OBJECT_LIST', 'OBJECT_PRINT'],
    }
  },
  'gcc': {
    'all': {
      'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
      'CXXFLAGS':     ['$CCFLAGS', '-fno-rtti', '-fno-exceptions'],
    },
    'visibility:hidden': {
      # Use visibility=default to disable this.
      'CXXFLAGS':     ['-fvisibility=hidden']
    },
    'strictaliasing:off': {
      'CCFLAGS':      ['-fno-strict-aliasing']
    },
    'mode:debug': {
      'CCFLAGS':      ['-g', '-O0'],
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER', 'DEBUG'],
      'os:android': {
        'CCFLAGS':    ['-mthumb']
      }
    },
    'mode:release': {
      'CCFLAGS':      ['-O3', '-fomit-frame-pointer', '-fdata-sections',
                       '-ffunction-sections'],
      'os:android': {
        'CCFLAGS':    ['-mthumb', '-Os'],
        'CPPDEFINES': ['SK_RELEASE', 'NDEBUG']
      }
    },
    'os:linux': {
      'CCFLAGS':      ['-ansi'] + GCC_EXTRA_CCFLAGS,
      'library:shared': {
        'CPPDEFINES': ['V8_SHARED'],
        'LIBS': ['pthread']
      }
    },
    'os:macos': {
      'CCFLAGS':      ['-ansi', '-mmacosx-version-min=10.4'],
      'library:shared': {
        'CPPDEFINES': ['V8_SHARED']
      }
    },
    'os:freebsd': {
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:openbsd': {
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:solaris': {
      # On Solaris, to get isinf, INFINITY, fpclassify and other macros one
      # needs to define __C99FEATURES__.
      'CPPDEFINES': ['__C99FEATURES__'],
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:win32': {
      'CCFLAGS':      ['-DWIN32'],
      'CXXFLAGS':     ['-DWIN32'],
    },
    'os:android': {
      'CPPDEFINES':   ['ANDROID', '__ARM_ARCH_5__', '__ARM_ARCH_5T__',
                       '__ARM_ARCH_5E__', '__ARM_ARCH_5TE__'],
      'CCFLAGS':      ANDROID_FLAGS,
      'WARNINGFLAGS': ['-Wall', '-Wno-unused', '-Werror=return-type',
                       '-Wstrict-aliasing=2'],
      'CPPPATH':      ANDROID_INCLUDES,
    },
    'arch:ia32': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_IA32'],
      'CCFLAGS':      ['-m32'],
      'LINKFLAGS':    ['-m32']
    },
    'arch:arm': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_ARM'],
      'unalignedaccesses:on' : {
        'CPPDEFINES' : ['CAN_USE_UNALIGNED_ACCESSES=1']
      },
      'unalignedaccesses:off' : {
        'CPPDEFINES' : ['CAN_USE_UNALIGNED_ACCESSES=0']
      }
    },
    'simulator:arm': {
      'CCFLAGS':      ['-m32'],
      'LINKFLAGS':    ['-m32'],
    },
    'arch:mips': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_MIPS'],
      'simulator:none': {
        'CCFLAGS':      ['-EL', '-mips32r2', '-Wa,-mips32r2', '-fno-inline'],
        'LDFLAGS':      ['-EL']
      }
    },
    'simulator:mips': {
      'CCFLAGS':      ['-m32'],
      'LINKFLAGS':    ['-m32'],
    },
    'arch:x64': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
      'CCFLAGS':      ['-m64'],
      'LINKFLAGS':    ['-m64'],
    },
    'gdbjit:on': {
      'CPPDEFINES':   ['ENABLE_GDB_JIT_INTERFACE']
    }
  },
  'msvc': {
    'all': {
      'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
      'CXXFLAGS':     ['$CCFLAGS', '/GR-', '/Gy'],
      'CPPDEFINES':   ['WIN32'],
      'LINKFLAGS':    ['/INCREMENTAL:NO', '/NXCOMPAT', '/IGNORE:4221'],
      'CCPDBFLAGS':   ['/Zi']
    },
    'verbose:off': {
      'DIALECTFLAGS': ['/nologo'],
      'ARFLAGS':      ['/NOLOGO']
    },
    'arch:ia32': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_IA32', '_USE_32BIT_TIME_T'],
      'LINKFLAGS':    ['/MACHINE:X86'],
      'ARFLAGS':      ['/MACHINE:X86']
    },
    'arch:x64': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
      'LINKFLAGS':    ['/MACHINE:X64'],
      'ARFLAGS':      ['/MACHINE:X64']
    },
    'mode:debug': {
      'CCFLAGS':      ['/Od', '/Gm'],
      'CPPDEFINES':   ['_DEBUG', 'ENABLE_DISASSEMBLER', 'DEBUG'],
      'LINKFLAGS':    ['/DEBUG'],
      'msvcrt:static': {
        'CCFLAGS': ['/MTd']
      },
      'msvcrt:shared': {
        'CCFLAGS': ['/MDd']
      }
    },
    'mode:release': {
      'CCFLAGS':      ['/O2'],
      'LINKFLAGS':    ['/OPT:REF', '/OPT:ICF'],
      'msvcrt:static': {
        'CCFLAGS': ['/MT']
      },
      'msvcrt:shared': {
        'CCFLAGS': ['/MD']
      },
      'msvcltcg:on': {
        'CCFLAGS':      ['/GL'],
        'ARFLAGS':      ['/LTCG'],
        'pgo:off': {
          'LINKFLAGS':    ['/LTCG'],
        },
        'pgo:instrument': {
          'LINKFLAGS':    ['/LTCG:PGI']
        },
        'pgo:optimize': {
          'LINKFLAGS':    ['/LTCG:PGO']
        }
      }
    }
  }
}


V8_EXTRA_FLAGS = {
  'gcc': {
    'all': {
      'WARNINGFLAGS': ['-Wall',
                       '-W',
                       '-Wno-unused-parameter',
                       '-Wnon-virtual-dtor']
    },
    'os:win32': {
      'WARNINGFLAGS': ['-pedantic', '-Wno-long-long']
    },
    'os:linux': {
      'WARNINGFLAGS': ['-pedantic'],
      'library:shared': {
        'soname:on': {
          'LINKFLAGS': ['-Wl,-soname,${SONAME}']
        }
      }
    },
    'os:macos': {
      'WARNINGFLAGS': ['-pedantic']
    },
    'disassembler:on': {
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
    }
  },
  'msvc': {
    'all': {
      'WARNINGFLAGS': ['/W3', '/WX', '/wd4351', '/wd4355', '/wd4800']
    },
    'library:shared': {
      'CPPDEFINES': ['BUILDING_V8_SHARED'],
      'LIBS': ['winmm', 'ws2_32']
    },
    'arch:arm': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_ARM'],
      # /wd4996 is to silence the warning about sscanf
      # used by the arm simulator.
      'WARNINGFLAGS': ['/wd4996']
    },
    'arch:mips': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_MIPS'],
    },
    'disassembler:on': {
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
    }
  }
}


MKSNAPSHOT_EXTRA_FLAGS = {
  'gcc': {
    'os:linux': {
      'LIBS': ['pthread'],
    },
    'os:macos': {
      'LIBS': ['pthread'],
    },
    'os:freebsd': {
      'LIBS': ['execinfo', 'pthread']
    },
    'os:solaris': {
      'LIBS': ['m', 'pthread', 'socket', 'nsl', 'rt'],

=== debian/changelog ===
nodejs (0.4.12-3) unstable; urgency=low

  * Depend on libv8 3.6 (>= 3.6.6.14-2), because it fixes CVE-2011-5037.
    This breaks test/simple/test-sys.js, fixed by an upstream patch.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 08 Jan 2012 12:00:02 +0100

nodejs (0.4.12-2) unstable; urgency=low

  * Port to libv8 3.5 branch and depend on it.
  * Force nodejs-dev to depend on libv8-dev << 3.6, to avoid API
    incompatibilities between nodejs-dev and libv8-dev.
    This will help fixing bug#650552, thanks to Jonas Smedegaard.
  * Do not search modules in /usr/local/lib/nodejs, see README.Debian.
  * Remove useless debian/patches/1006_version.patch
  * Drop unneeded dependency on Scons.
  * Build-Depends on openssl, some tests spawn /usr/bin/openssl.

 -- Jérémy Lal <kapouer@melix.org>  Mon, 05 Dec 2011 11:34:27 +0100

nodejs (0.4.12-1) unstable; urgency=low

  * New upstream release 
  * Port to libv8 3.4 branch and depend on it. Closes:bug#642731.
  * debian/gbp.conf: fix syntax, filter 'doc/logos/*' or else
    pristine-tar will complain.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 27 Sep 2011 16:10:10 +0200

nodejs (0.4.11-1) unstable; urgency=low

  * New upstream release
  * debian/gbp.conf: Filter out doc/logos, unused, too big, and
    upstream removed it from 0.5 tarballs.
  * debian/patches/1006_version.patch : upstream forgot to update
    VERSION flag in wscript.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 18 Aug 2011 15:09:01 +0200

nodejs (0.4.10-1) unstable; urgency=low

  * New upstream release 

 -- Jérémy Lal <kapouer@melix.org>  Wed, 20 Jul 2011 20:50:07 +0200

=== debian/control ===
Source: nodejs
Section: web
Priority: extra
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Dave Beckett <dajobe@debian.org>,
 Jonas Smedegaard <dr@jones.dk>
DM-Upload-Allowed: yes
Build-Depends: cdbs (>= 0.4.70~),
 devscripts,
 debhelper,
 dh-buildinfo,
 python,
 libev-dev (>= 4.0),
 libv8-dev (>= 3.6.6.14-2),
 libc-ares-dev (>= 1.7.3),
 binutils,
 libssl-dev (>= 0.9.8),
 openssl (>= 0.9.8),
 pkg-config,
 bash-completion,
 curl
Standards-Version: 3.9.2
Homepage: http://nodejs.org/
Vcs-Browser: http://git.debian.org/?p=collab-maint/nodejs.git
Vcs-Git: git://git.debian.org/git/collab-maint/nodejs.git

Package: nodejs-dev
Section: devel
Architecture: any
Depends: nodejs (= ${binary:Version}),
 ${misc:Depends},
 python,
 libev-dev (>= 4.0),
 libv8-dev (>= 3.6.6.14-2), libv8-dev (<< 3.7),
 libc-ares-dev (>= 1.7.3),
 libssl-dev (>= 0.9.8)
Description: Development files for Node.js
 Node.js provides an event-based server-side javascript engine.
 .
 It is similar in design to and influenced by systems like
 Ruby's Event Machine or Python's Twisted.
 .
 Node.js takes the event model a bit further - it presents the event
 loop as a language construct instead of as a library.
 .
 This package is needed to build plugins.

Package: nodejs
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Conflicts: node
Description: Node.js event-based server-side javascript engine
 Node.js is similar in design to and influenced by systems like
 Ruby's Event Machine or Python's Twisted.
 .
 It takes the event model a bit further - it presents the event
 loop as a language construct instead of as a library.
 .
 Node.js is bundled with several useful libraries to handle server tasks :
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: nodejs-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends},
 nodejs (= ${binary:Version})
Suggests: libv8-dbg
Description: Node.js event-based server-side javascript engine (debug)
 Node.js is similar in design to and influenced by systems like
 Ruby's Event Machine or Python's Twisted.
 .
 It takes the event model a bit further - it presents the event
 loop as a language construct instead of as a library.
 .
 Node.js is bundled with several useful libraries to handle server tasks :
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

DEB_UPSTREAM_URL = http://nodejs.org/dist
DEB_UPSTREAM_TARBALL_BASENAME = node-v$(DEB_UPSTREAM_TARBALL_VERSION)

# suppress checking binary files, to not upset dpkg-source
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(doc/trademark-policy\.pdf|doc/joyent-logo_orange_nodeorg-01\.png|debian/(changelog|copyright(|_hints|_newhints)))$

DEB_CONFIGURE_NORMAL_ARGS = ""
DEB_CONFIGURE_EXTRA_FLAGS = --debug --shared-v8 --shared-cares --shared-libev --no-ssl2
DEB_CONFIGURE_SCRIPT_ENV += PREFIX="/usr"
DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean
#  * relax regression tests when targeted experimental suite
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -Fx 'Distribution: experimental'),-i)
DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test

# properly clean files from build, waf, test, python
clean::
	rm -f node
	rm -f node_g
	rm -f .lock-wscript
	rm -rf build
	rm -f test/fixtures/hello.txt
	rm -rf test/tmp
	find . -name "*.pyc" -delete

# we have completion for nodejs-waf
install/nodejs-dev::
	dh_bash-completion

# rename and install binary in nodejs-dbg
install/nodejs-dbg::
	mv $(CURDIR)/debian/tmp/usr/bin/node_g $(CURDIR)/debian/nodejs-dbg/usr/lib/debug/usr/bin/node
